; Still performing TFR when /T, though results hidden - sth's wrong without TFR

;
;	Chris Dragan's PC speed benchmark Version 4.8 (26.10.98)
;
;	Compile it like this:
;		nasm -opcspeed.com pcspeed.asm
;

org 100h
section .text

	jmp	main

;
;	DrawNumber
;

DrawNumber
	push	eax				; Save number and draw string
	mov	ah, 09h
	int	21h
	pop	eax
	push	eax

	xor	edx, edx			; Calculate
	mov	ebx, 100
	div	ebx
	mov	di, freemem+9			; After comma
	mov	[di+1], byte '$'
	mov	bx, 10
	xor	edx, edx
	div	ebx
	add	dl, '0'
	mov	[di], dl
	mov	[di-1], byte '.'
	sub	di, 2
	mov	cx, 8

lb_0F:	xor	edx, edx			; Before comma
	div	ebx
	add	dl, '0'
	mov	[di], dl
	dec	di
	dec	cx
	or	eax, eax
	jnz	lb_0F
	mov	al, ' ' 			; spaces
	std
	rep	stosb
	cld

	mov	dx, freemem			; Draw
	mov	ah, 09h
	int	21h

	pop	eax
	ret

;
;	PrintWordHex
;

PrintWordHex
	xchg	al, ah
	call	PrintByteHex
	mov	al, ah
	call	PrintByteHex
	mov	ah, 09h
	ret

;
;	PrintByteHex
;

PrintByteHex
	pusha
	mov	cx, 2
	mov	bl, al
lb_0C:	ror	bl, 4
	mov	dl, bl
	and	dl, 0Fh
	add	dl, 30h
	cmp	dl, 3Ah
	jc	lb_0D
	add	dl, 07h
lb_0D:	mov	ah, 02h
	int	21h
	loop	lb_0C
	popa
	ret

;
;	PrintDwordDec
;

PrintDwordDec
	mov	ebx, 10
	xor	cx, cx
lb_21:	xor	edx, edx
	div	ebx
	add	dl, '0'
	push	dx
	inc	cx
	or	eax, eax
	jnz	lb_21
	mov	ah, 02h
lb_22:	pop	dx
	int	21h
	loop	lb_22
	ret

;
;	main
;

main
	mov	cl, [80h]			; Find /C parameter in cmdline
	mov	ch, 00h
	or	cx, cx
	jz	par_9
	mov	si, 81h
	cld
par_1:	lodsb					; Find slash
	cmp	al, '/'
	jnz	par_8
	dec	cx
	jz	par_9
	lodsb					; Get param
	cmp	al, 'a' 			; UpCase(param)
	jc	_case
	cmp	al, 'z'
	ja	_case
	sub	al, 'a'-'A'
_case:	mov	di, Params			; Find in the param list
	push	cx
	mov	cx, 4	; <- number of supported parameters
	repnz	scasb
	pop	cx
	jnz	par_8
	cmp	cl, 1
	jz	par_2
	cmp	[si], byte '/'			; Follows space or switch ?
	jz	par_2
	cmp	[si], byte ' '
	jnz	par_8
par_2:	cmp	al, '?'
	jnz	par_7
	mov	dx, txt0
	call	PrintText
	int	20h
par_7:	cmp	al, 'C'
	jnz	par_5
	mov	[PageFlags], byte 1Fh
	jmp	par_8
par_5:	cmp	al, 'T'
	jnz	par_6
	mov	[NoTFR], byte 1
	jmp	par_8
par_6:	add	[Delay], byte 18
par_8:	loop	par_1

par_9:	mov	dx, No386			; Test for 386
	mov	ax, 7202h
	push	ax
	popf
	pushf
	pop	ax
	cmp	ah, 0F0h
	jnc	lb_02				; XT
	test	ah, 0F0h
	jz	lb_02				; AT in real mode
; note that at this place AX is non-zero as it should be
	fninit					; Coprocessor check
	fnstsw	ax
	or	ax, ax
	jnz	_nofpu
	fnstcw	[RandSeed]
	mov	ax, [RandSeed]
	and	ax, 103Fh
	cmp	ax, 003Fh
	setz	[IsCopro]

_nofpu: mov	ah, 00h 			; Init random seed
	int	1Ah
	mov	[RandSeed], dx
	mov	[RandSeed+2], cx

	mov	ax, 3D00h			; Check EMS
	mov	dx, EMMDrvName
	int	21h
	jc	lb_xms
	mov	bx, ax
	mov	ax, 4407h
	int	21h
	cmp	al, 0
	jz	lb_xms

	mov	ax, 0DE00h			; VCPI installation check
	int	67h
	cmp	ah, 00h
	jz	near lb_03

lb_xms: smsw	ax				; Check PE bit in CR0
	test	al, 01h
	jz	xm_07

lb_01:	mov	dx, NoVCPIXMS			; Error message
lb_02:	call	PrintText

	mov	ax, 4C02h			; Quit
	int	21h

lb_uh:	call	Unhook67h
	jmp	lb_02

xm_07:	mov	ax, 4300h			; XMS installation check
	int	2Fh
	cmp	al, 80h
	jnz	lb_01
	mov	byte [OnXMS], 01h

	mov	ax, 4310h			; Get XMM entry point
	int	2Fh
	mov	[XMM], bx
	mov	[XMM+2], es
	push	ds
	pop	es

	mov	di, XMSBlockBuffer
xm_01:	mov	ah, 08h 			; Query largest XMS block
	mov	bl, 00h
	call	far [XMM]
	cmp	bl, 00h
	jnz	xm_02
	cmp	ax, 4
	jc	xm_02

%define xbAddress  0
%define xbHandle   4
%define xbNumPages 6

	shr	ax, 2				; Allocate largest XMS block
	mov	[di+xbNumPages], ax
	add	[NumXMSPages], ax
	shl	ax, 2
	mov	dx, ax
	mov	ah, 09h
	call	far [XMM]
	cmp	ax, 1
	jnz	xm_02
	mov	[di+xbHandle], dx

	mov	ah, 0Ch 			; Lock allocated block
	call	far [XMM]
	mov	[di+xbAddress], bx
	mov	[di+xbAddress+2], dx

	add	di, 8				; Next block
	inc	byte [NumXMSBlocks]
	cmp	[NumXMSBlocks], byte 32
	jc	xm_01

xm_02:	push	es				; Hook int67h
	mov	ax, 3567h
	int	21h
	mov	[Saved67h], bx
	mov	[Saved67h+2], es
	pop	es
	push	ds
	push	cs
	pop	ds
	mov	dx, VCPIEmu
	mov	ax, 2567h
	int	21h
	pop	ds

	mov	ah, 07h 			; Get A20 state
	call	far [XMM]
	neg	al
	add	al, 4
	mov	[A20State], al

lb_03:	mov	ax, 0DE03h			; Get amount of free pages
	int	67h
	mov	[NumFreePages], edx
	cmp	edx, 512
	mov	dx, NoMemory
	jc	near lb_uh

	call	UpdateSystem32			; Update GDT and IDT

	mov	ah, 09h 			; Message
	mov	dx, txt0
	int	21h
	mov	dx, txtdelay
	int	21h

_wait:	in	al, 60h 			; Wait for key release
	test	al, 80h
	hlt
	jz	_wait
	hlt

	cmp	[Delay], word 0 		; User defined delay
	jz	_nodelay
	mov	ah, 00h
	int	1Ah
	shl	ecx, 16
	mov	cx, dx
	mov	eax, [Delay]
	add	ecx, eax
	mov	esi, ecx
_delay: hlt
	mov	ah, 00h
	int	1Ah
	shl	ecx, 16
	mov	cx, dx
	cmp	ecx, esi
	jc	_delay

_nodelay:
	mov	ah, 09h 			; Additional strings
	mov	dx, txtmode
	int	21h
	mov	dx, txtmode1
	cmp	[OnXMS], byte 0
	jz	_vcpit
	mov	dx, txtmode2
_vcpit: int	21h
	mov	dx, txtmem
	int	21h
	mov	eax, [NumFreePages]
	shr	eax, 8
	cmp	eax, 16
	jna	_l16
	mov	eax, 16
_l16:	call	PrintDwordDec
	mov	ah, 09h
	mov	dx, txt1
	int	21h

	cli					; Init PICs
	in	al, 21h
	mov	ah, al
	in	al, 0A1h
	mov	[SaveIRQs], ax
	mov	si, MyPICs
	call	ProgPICs

	mov	al, 34h 			; Reset timer
	out	43h, al
	mov	al, 00h
	out	40h, al
	out	40h, al

	mov	[SaveSP], sp			; Save important registers
	mov	[SavePSP], cs

	mov	cx, EntryData			; Switch to PM
	call	CalcLinearAddr
	mov	esi, eax
	mov	ax, 0DE0Ch
	int	67h

;
;	return from protected mode
;

lb_07:	mov	si, DOSPICs			; Restore PICs
	call	ProgPICs
	mov	ax, [SaveIRQs]
	out	0A1h, al
	mov	al, ah
	out	21h, al
	sti

	call	Unhook67h

	cmp	[EndFlag], byte 1		; Check if an error occured
	jz	near lb_0A
	cmp	[EndFlag], byte 2
	jz	near lb_0B
	cmp	[EndFlag], byte 3
	jz	near lb_0B2

	mov	dx, txt4			; Show performance
	mov	eax, [ArithTestResult]
	call	DrawNumber
	shl	eax, 2
	mov	[OverallResult], eax
	mov	dx, txt_copro
	cmp	[IsCopro], byte 0
	jnz	_fpur
	mov	eax, [ArithTestResult]
	shr	eax, 2
	add	[OverallResult], eax
	mov	ah, 09h
	int	21h
	mov	dx, txt_nofpu
	int	21h
	jmp	_cmmx
_fpur:	mov	eax, [CoproTestResult]
	call	DrawNumber
	shl	eax, 1
	add	[OverallResult], eax
_cmmx:	mov	dx, txt_mmx
	cmp	[IsMMX], byte 0
	jnz	_mmxr
	mov	eax, [ArithTestResult]
	shr	eax, 1
	add	[OverallResult], eax
	mov	ah, 09h
	int	21h
	mov	dx, txt_nommx
	int	21h
	jmp	_memr
_mmxr:	mov	eax, [MMXTestResult]
	call	DrawNumber
	shl	eax, 1
	add	[OverallResult], eax
_memr:	mov	dx, txt_mem
	mov	eax, [MemTestResult]
	call	DrawNumber
	shl	eax, 2
	add	[OverallResult], eax
	mov	dx, txt_jmp
	mov	eax, [JumpTestResult]
	call	DrawNumber
	lea	eax, [eax*2+eax]
	add	eax, [OverallResult]
	cdq
	mov	ecx, 20
	idiv	ecx
	mov	dx, txt_overall
	call	DrawNumber
	mov	ah, 09h
	mov	dx, txt6
	int	21h

	cmp	[IsCPUID], byte 0		; CPUID test results
	jz	_fea1
	mov	dx, txt8
	int	21h
	mov	ah, 02h 			; Vendor string
	mov	si, VendorString
	cld
	mov	cx, 12
lb_1E:	lodsb
	mov	dl, al
	int	21h
	loop	lb_1E
	mov	dl, '"'
	int	21h
	mov	ah, 09h
_fea1:	cmp	[IsModel], byte 0		; CPUID model
	jz	_fea2
	mov	dx, txt9
	int	21h
	mov	ax, [CPUIDModel]
	call	PrintWordHex
_fea2:	cmp	[NoTFR], byte 0 		; TFR model
	jnz	_fea4
	cmp	[OnXMS], byte 0
	jz	_fea4
	mov	dx, txt10
	int	21h
	mov	ax, [TFRModel]
	call	PrintWordHex
_fea4:	cmp	[IsCyrix], byte 0		; Cyrix model
	jz	_fea5
	mov	dx, txt11
	int	21h
	mov	ax, [CyrixID]
	call	PrintWordHex
_fea5:	cmp	[IsTSC], byte 0 		; Clock rate
	jz	_fea6
	mov	dx, txt12
	int	21h
	mov	eax, [BusSpeed]
	call	PrintDwordDec
	mov	ah, 09h
	mov	dx, txt16
	int	21h
_fea6:	cmp	[IsModel], byte 0		; Features
	jz	_fea7
	mov	dx, txt13
	int	21h
	mov	ax, [Capabilities+2]
	call	PrintWordHex
	mov	ax, [Capabilities]
	call	PrintWordHex
_fea7:	cmp	[IsExtraFeat], byte 0
	jz	_fea8
	mov	dx, txt14
	int	21h
	mov	ax, [ExtraFeatures+2]
	call	PrintWordHex
	mov	ax, [ExtraFeatures]
	call	PrintWordHex
_fea8:	mov	ah, 09h
	mov	dx, EOL
	int	21h

lb_08:	in	al, 60h 			; Empty keyboard buffer
lb_09:	mov	ah, al
	in	al, 60h
	cmp	al, ah
	jnz	lb_09

	mov	ah, 4Ch 			; Exit
	mov	al, [ExitCode_]
	int	21h

lb_0A:	mov	dx, txt2			; Exception occured
	mov	ah, 09h
	int	21h
	mov	al, [Exception] 		; Exception number
	call	PrintByteHex
	movzx	bx, [Exception] 		; Extra word on stack
	cmp	[exceptionextra+bx], byte 0
	jz	lb_0A2
	mov	ah, 09h
	mov	dx, txt22
	int	21h
	mov	ax, [ExtraWord]
	call	PrintWordHex
lb_0A2: mov	ah, 09h 			; Address of error
	mov	dx, txt21
	int	21h
	mov	ax, [ExceptionAddr+4]
	call	PrintWordHex
	mov	ah, 02h
	mov	dl, ':'
	int	21h
	mov	ax, [ExceptionAddr+2]
	call	PrintWordHex
	mov	ax, [ExceptionAddr]
	call	PrintWordHex
	mov	ah, 09h 			; End of line
	mov	dx, EOL
	int	21h
	mov	[ExitCode_], byte 2
	jmp	lb_08

lb_0B:	mov	dx, txt3			; Interrupt occured
	mov	[ExitCode_], byte 2
lb_0B1: call	PrintText
	jmp	lb_08
lb_0B2: mov	dx, txt31
	mov	[ExitCode_], byte 1
	jmp	lb_0B1

;
;	UpdateSystem32
;

UpdateSystem32
	mov	cx, freemem			; Setup page directory beginning
	call	CalcLinearAddr
	dec	eax
	shr	eax, 12
	inc	eax
	shl	eax, 12
	xor	ecx, ecx
	mov	cx, cs
	shl	ecx, 4
	mov	edi, eax
	sub	edi, ecx
	mov	edx, eax
	call	GetPageAddr
	mov	[_CR3], eax
	mov	[TSS+1Ch], eax
	mov	[TSS+64h], dword 00680000h
	push	di
	mov	cx, 5
lb_04:	add	edx, 1000h
	mov	eax, edx
	call	GetPageAddr
	stosd
	loop	lb_04
	xor	eax, eax
	mov	cx, 6*1024-5
	rep	stosd
	pop	di
	add	di, 2000h
	mov	[FreeMem], di
	sub	di, 1000h

	mov	ax, 0DE01h			; Get PM interface
	mov	si, sel_vcpi
	int	67h
	mov	[sel_gate], bx
	shr	ebx, 16
	mov	[sel_gate+6], bx

	mov	bx, sel_tss			; Setup GDT
	mov	cx, TSS
	mov	dx, 0067h
	call	SetupSel
	xor	cx, cx
	mov	dx, -1
	call	SetupSel
	call	SetupSel
	call	SetupSel

	mov	cx, GDT 			; Setup GDTR and IDTR
	call	CalcLinearAddr
	mov	[GDTAddr], eax
	mov	cx, GDTR
	call	CalcLinearAddr
	mov	[GDTRAddr], eax
	mov	cx, IDT
	call	CalcLinearAddr
	mov	[IDTAddr], eax
	mov	cx, IDTR
	call	CalcLinearAddr
	mov	[IDTRAddr], eax

	mov	cx, 20h 			; Update IDT - exceptions
	mov	eax, 00300000h+exceptions
	mov	edx, 00008E00h
	mov	di, IDT
lb_05:	stosd
	mov	[di], edx
	add	di, 4
	inc	eax
	loop	lb_05
	mov	[IDT+(8*3)], word exception

	mov	cx, 10h 			; Update IDT - interrupts
	mov	eax, 00300000h+interrupt
	mov	edx, 00008E00h
lb_06:	stosd
	mov	[di], edx
	add	di, 4
	loop	lb_06
	mov	[IDT+(8*20h)], word timer
	mov	[IDT+(8*21h)], word keyboard
	ret

;
;	SetupSel
;

SetupSel
	push	ax				; cs:cx - segment base
	push	cx				; dx	- segment limit
	mov	[bx], dx			; ds:bx - descriptor address
	call	CalcLinearAddr
	mov	[bx+2], ax
	shr	eax, 16
	mov	[bx+4], al
	mov	[bx+7], ah
	add	bx, 8
	pop	cx
	pop	ax
	ret

;
;	CalcLinearAddr
;

CalcLinearAddr
	xor	eax, eax			; cs:cx - address
	mov	ax, cs
	shl	eax, 4
	movzx	ecx, cx
	add	eax, ecx
	ret

;
;	GetPageAddr
;

GetPageAddr
	push	cx
	push	edx
	shr	eax, 12 			; eax - address
	mov	cx, ax
	mov	ax, 0DE06h
	int	67h
	mov	eax, edx
	mov	al, 07h
	pop	edx
	pop	cx
	ret

;
;	ProgPICs
;

ProgPICs					; Program PICs (values in ds:si)
	mov	dx, 0020h
	outsb
	inc	dx
	outsb
	outsb
	outsb
	mov	dx, 00A0h
	outsb
	inc	dx
	outsb
	outsb
	outsb
	ret

;
;	PrintText
;

PrintText
	mov	ah, 09h
	int	21h
	mov	dx, EOL
	int	21h
	ret

;
;	Unhook67h
;

Unhook67h
	cmp	[OnXMS], byte 1 		; Test if on XMS
	jnz	xm_04

	cmp	[Is386], byte 1 		; Invalidate cache
	jz	xm_11
	wbinvd
	mov	eax, cr3
	mov	cr3, eax

xm_11:	push	ds				; Release int67h vector
	mov	dx, [Saved67h]
	mov	ds, [Saved67h+2]
	mov	ax, 2567h
	int	21h
	pop	ds

	movzx	cx, [NumXMSBlocks]		; Release XMS
	jcxz	xm_04
	mov	di, XMSBlockBuffer
xm_03:	mov	ah, 0Dh 			; Unlock block
	mov	dx, [di+xbHandle]
	call	far [XMM]
	mov	ah, 0Ah 			; Release block
	call	far [XMM]
	add	di, 8				; Next block to release
	loop	xm_03

xm_04:	ret

;
;	VCPIEmu
;

VCPIEmu 					; VCPI emulation
	cmp	ax, 0DE01h
	jz	_DE01
	cmp	ax, 0DE03h
	jz	_DE03
	cmp	ax, 0DE06h
	jz	_DE06
	cmp	ax, 0DE0Ch
	jz	_DE0Cr
	iret
						; Get PM interface
_DE01:	pushad					; Update selectors
	mov	bx, si
	xor	cx, cx
	mov	dx, -1
	call	SetupSel
	call	SetupSel
	call	SetupSel

	mov	eax, 00000007h			; Update page descriptors
	mov	cx, 100h
	cld
xm_05:	stosd
	add	eax, 00001000h
	loop	xm_05

	popad					; Rest of stuff
	add	di, 400h
	mov	ebx, VCPIEmu32
	mov	ah, 00h
	mov	[retjmp+3], cs			; Update return jump address
	iret

_DE03:	movzx	edx, word [NumXMSPages] 	; Get number of free pages
	mov	ah, 00h
	iret

_DE06:	movzx	edx, cx 			; Get RM page physical addres
	shl	edx, 12
	mov	ah, 00h
	iret
						; Enter PM
_DE0Cr: mov	ah, 03h 			; Enable A20
	call	far [XMM]
	sidt	[SaveIDTR]			; Save DTRs
	sgdt	[SaveGDTR]
	mov	eax, cr0			; Prepare new CR0
	or	eax, 80000001h
	mov	ecx, [_CR3]			; Update CR3
	mov	cr3, ecx
	lgdt	[GDTR]				; Load GDTR
	mov	cr0, eax			; Enter PM and enable paging
	jmp	0008h:pm_entry
						; Here returning from PM
pm_16:	mov	eax, 0010h			; Reload segments
	mov	ds, eax
	mov	es, eax
	mov	fs, eax
	mov	gs, eax
	mov	eax, cr0			; Switch off paging
	btc	eax, 31
	mov	cr0, eax
	xor	edx, edx
	mov	cr3, edx
	and	al, 0FEh			; Switch to real mode
	mov	cr0, eax
retjmp: jmp	0:rm_entry			; Reload CS

rm_entry:
	mov	ax, cs				; Restore segregs and sp
	mov	ds, ax
	mov	es, ax
	mov	fs, ax
	mov	gs, ax
	mov	ss, ax
	mov	sp, [SaveSP]
	lidt	[SaveIDTR]			; Restore DTRs
	lgdt	[SaveGDTR]
	cmp	[NoTFR], byte 0 		; TFR
	jnz	_notfr
	call	TripleFaultReset
_notfr: mov	ah, [A20State]			; Restore A20 state
	call	far [XMM]
	jmp	lb_07

;
;	TripleFaultReset
;

TripleFaultReset
	mov	ah, 04h 			; Disable A20 gate
	call	far [XMM]

	mov	cx, TFRGDT			; Update TFR data
	call	CalcLinearAddr
	mov	[TFRGDTBase], eax
	xor	cx, cx
	mov	dx, -1
	mov	bx, TFRGDT+8
	call	SetupSel

	cli					; Prepare BIOS to TFR
	mov	[SaveSP], sp
	mov	al, 0Fh
	out	70h, al
	jmp	short .a1
.a1	jmp	short .a2
.a2	jmp	short .a3
.a3	mov	al, 0Ah
	out	71h, al

	push	word 0
	pop	es
	mov	[es:0467h], word _tfr		; Pre-POST jump address
	mov	[es:0469h], cs
	mov	[es:0472h], word 0		; Shutdown status

	lgdt	[TFRGDTR]			; Switch to PM
	lidt	[TFRIDTR]
	smsw	ax
	or	al, 01h
	lmsw	ax
	jmp	0008h:_reset			; Reload CS
_reset: mov	ax, [cs:0FFFFh] 		; Perform TFR

_tfr:	cli					; Return from TFR
	mov	ax, cs
	mov	ds, ax
	mov	es, ax
	mov	ss, ax
	mov	sp, [SaveSP]
	mov	[TFRModel], dx
	ret

bits 32
code32

;
;	main32
;

main32
	mov	eax, 0038h			; Update segment registers
	mov	ds, eax
	mov	es, eax
	mov	fs, eax
	mov	gs, eax
	mov	eax, 0040h
	mov	ss, eax
	movzx	esp, word [SaveSP]

	mov	ecx, [NumFreePages]		; Get amount of free pages
	cmp	ecx, 4096
	jna	lb_12
	mov	ecx, 4096
	mov	[NumFreePages], ecx

lb_12:	movzx	edi, word [FreeMem]		; Fill tested memory pages
	cld
lb_13:	mov	ax, 0DE04h
	call	0020h:0
	mov	dl, 07h
	mov	eax, edx
	stosd
	loop	lb_13
	sti
	mov	ecx, 4096
	mov	edx, [NumFreePages]
	sub	ecx, edx
	jz	lb_14
	movzx	esi, word [FreeMem]
	rep	movsd

lb_14:	pushfd					; Check if 486 and for ID flag
	pushfd
	pop	eax
	mov	ecx, eax
	xor	eax, 00240000h
	push	eax
	popfd
	pushfd
	pop	eax
	popfd
	xor	eax, ecx
	shr	eax, 19
	setnc	[Is386]
	test	al, 04h
	jnz	near _cpuid
	cmp	[Is386], byte 0
	jnz	near lb_1D

	mov	ax, 5				; Cyrix test
	mov	bl, 2
	sahf
	div	bl
	lahf
	cmp	ah, 2
	jnz	_hardcpuid
	call	GetCyrixID

	mov	al, 0C3h			; Enable other CCRs than
	call	ReadCCR 			; only C0..CF, FE, FF
	and	ah, 0Fh 			; (CCR3 bits 7..4 = 0001b)
	or	ah, 10h
	call	WriteCCR

	mov	al, 0E8h			; Enable CPUID
	call	ReadCCR 			; (CCR4 bit 7 = 1)
	or	ah, 80h
	call	WriteCCR

_hardcpuid:
	mov	[IDT+(8*6)], word _nocpuid	; Hook exc06
	xor	eax, eax
	cpuid					; Force CPUID
	mov	[IDT+(8*6)], word exceptions+6	; Here we are if CPUID supported
	jmp	_cpuid
_nocpuid:
	add	esp, 12 			; Here we are if not supported
	mov	[IDT+(8*6)], word exceptions+6
	sti
	jmp	lb_1D

_cpuid: inc	byte [IsCPUID]
	xor	eax, eax			; Identify processor
	cpuid
	mov	[VendorString], ebx
	mov	[VendorString+4], edx
	mov	[VendorString+8], ecx
	or	ax, ax
	setnz	[IsModel]
	jz	_extf
	mov	eax, 1
	cpuid
	mov	[CPUIDModel], ax
	mov	[Capabilities], edx
	bt	edx, 23 			; MMX check
	setc	[IsMMX]

	test	dl, 10h 			; Determine busclock speed [MHz]
	setnz	[IsTSC]
	jz	_extf
	hlt
	rdtsc
	mov	ecx, edx
	mov	ebx, eax
	hlt
	rdtsc
	sub	eax, ebx
	sbb	edx, ecx
	mov	ecx, 54925
	div	ecx
	mov	[BusSpeed], eax

_extf:	mov	eax, 80000000h			; Get extended features
	cpuid
	cmp	eax, 80000000h
	seta	[IsExtraFeat]
	jna	_cyrixid
	mov	eax, 80000001h
	cpuid
	mov	[ExtraFeatures], edx

_cyrixid:					; Get Cyrix ID
	cmp	[VendorString], dword 'Cyri'
	jnz	lb_1D
	call	GetCyrixID

lb_1D:	mov	esi, ArithTest			; Performance tests
	mov	ebx, ArithTestEnd - ArithTest
	call	ExecuteTest
	mov	[ArithTestResult], ecx
	mov	esi, MemTest
	mov	ebx, MemTestEnd - MemTest
	call	ExecuteTest
	mov	[MemTestResult], ecx
	mov	esi, JumpTest
	mov	ebx, JumpTestEnd - JumpTest
	call	ExecuteJumpTest
	mov	[JumpTestResult], ecx
	cmp	[IsMMX], byte 0 		; MMX test
	jz	_nommx
	mov	eax, [RandSeed]
	imul	eax, 08088405h
	mov	[_mm0], eax
	imul	eax, 08088405h
	imul	eax, 08088405h
	mov	[_mm0+4], eax
	movq	mm0, [_mm0]
	movq	mm3, [_mm3]
	movq	mm4, [_mm4]
	movq	mm5, [_mm5]
	movq	mm6, [_mm6]
	mov	esi, MMXTest
	mov	ebx, MMXTestEnd - MMXTest
	call	ExecuteTest
	movd	[MMXTestResult], mm5
	emms
_nommx: cmp	[IsCopro], byte 0		; FPU test
	jz	lb_16
	fninit
	fld	tword [NRoot]
	fild	dword [NRand]
	fld	tword [NBond]
	fild	dword [RandSeed]
	mov	esi, CoproTest
	mov	ebx, CoproTestEnd - CoproTest
	call	ExecuteTest
	mov	[CoproTestResult], ecx
	fninit

lb_16:	mov	ecx, [NumFreePages]		; Free allocated memory
	movzx	esi, word [FreeMem]
	cli
lb_17:	lodsd
	mov	edx, eax
	and	dx, 0F000h
	mov	ax, 0DE05h
	call	0020h:0
	loop	lb_17

	mov	ecx, esp			; Return to VM
	mov	[SaveSP], cx
	mov	eax, [SavePSP]
	push	eax
	push	eax
	push	eax
	push	eax
	push	eax
	push	ecx
	sub	esp, 4
	push	eax
	mov	eax, lb_07
	push	eax
	mov	eax, 0010h
	mov	ds, eax
	mov	ax, 0DE0Ch
	call	0020h:0

;
;	ExecuteTest
;

ExecuteTest
	mov	eax, 0048h			; Fill test code
	mov	es, eax
	xor	edi, edi
	mov	eax, [NumFreePages]		; Calc number of instr blocks
	shl	eax, 12
	sub	eax, 5
	xor	edx, edx
	div	ebx
	mov	edx, eax
	cld					; The loop
	mov	eax, 0030h
	mov	ds, eax
	mov	eax, esi
lb_19:	mov	esi, eax
	mov	ecx, ebx
	rep	movsb
	dec	edx
	jnz	lb_19
	mov	[es:edi], byte 0E9h		; Add code: 'jmp 0'
	lea	eax, [edi+5]
	neg	eax
	mov	[es:edi+1], eax

_cach:	mov	eax, 0038h			; Is cache forced to be disabled
	mov	ds, eax
	cmp	[PageFlags], byte 07h
	jz	_nodis

	movzx	edi, word [FreeMem]		; Disable cache at page level
	mov	al, 1Fh
	mov	ecx, 1000h
_dis:	mov	[edi], al
	add	edi, 4
	loop	_dis
	sub	edi, 6000h
	mov	[edi+4], byte 1Fh
	mov	[edi+8], byte 1Fh
	mov	[edi+12], byte 1Fh
	mov	[edi+16], byte 1Fh

_nodis: cmp	[Is386], byte 0 		; Invalidate cache
	jnz	lb_15
	wbinvd
	mov	eax, cr3
	mov	cr3, eax

lb_15:	xor	ebx, ebx			; Prepare to test
	xor	ecx, ecx
	mov	eax, [RandSeed]
	mov	edx, 0048h
	mov	ds, edx
	hlt
	mov	[fs:IDT+(8*20h)], word lb_18
	jmp	0050h:0

lb_18:	mov	eax, 0038h			; End of interrupt
	mov	ds, eax
	mov	es, eax
	mov	al, 20h
	out	20h, al
	add	esp, 3*4
	mov	[IDT+(8*20h)], word timer
	sti

	cmp	[PageFlags], byte 07h		; Enable cache
	jz	_nods2
	push	ecx
	movzx	edi, word [FreeMem]
	mov	ecx, 1000h
	mov	al, 1Fh
_dis2:	mov	[edi], al
	add	edi, 4
	loop	_dis2
	sub	edi, 6000h
	mov	[edi+4], byte 07h
	mov	[edi+8], byte 07h
	mov	[edi+12], byte 07h
	mov	[edi+16], byte 07h
	pop	ecx
_nods2: ret

;
;	ExecuteJumpTest
;

ExecuteJumpTest
	mov	eax, 0048h			; Prepare to filling
	mov	es, eax
	mov	edx, [NumFreePages]
	shl	edx, 7
	mov	eax, 0030h
	mov	ds, eax
	xor	eax, eax
	cld
et2_1:	mov	edi, eax			; Some NOPs
	mov	[es:edi], dword 90909090h
	mov	ecx, edx
	and	ecx, 03h
	add	edi, ecx
	mov	ecx, ebx			; Test code
	rep	movsb
	sub	esi, ebx			; Next paragraph (every 32bytes)
	add	eax, 20h
	dec	edx
	jnz	et2_1
	jmp	_cach

;
;	ArithTest
;

ArithTest
	inc	ecx
	mov	edx, 08088405h
	mul	edx
	mov	ebx, eax
	cdq
	idiv	ecx
	lea	eax, [eax*2+edx+3]
	rol	edx, cl
	xor	edx, edx
	div	ecx
	imul	edx
	sbb	eax, edx
	mov	eax, ebx
ArithTestEnd

;
;	CoproTest
;

CoproTest
	fmul	st0, st2
	fprem
	fld	st3
	fld	st1
	fyl2xp1
	fld	st0
	frndint
	fsub	st1, st0
	fld1
	fscale
	fstp	st1
	fxch	st1
	f2xm1
	fld1
	faddp	st1, st0
	fmulp	st1, st0
	ffree	st0
	fincstp
	inc	ecx
CoproTestEnd

;
;	MMXTest
;

MMXTest
	pmullw	mm0, mm3
	movq	mm1, mm0
	movq	mm2, mm0
	psllq	mm1, 32
	psrlq	mm2, 32
	por	mm1, mm2
	pmaddwd mm1, mm0
	movq	mm2, mm0
	punpcklwd mm2, mm4
	paddd	mm1, mm2
	packssdw mm2, mm1
	packssdw mm1, mm1
	pmulhw	mm1, mm2
	pmullw	mm2, mm1
	paddd	mm5, mm6
MMXTestEnd

;
;	MemTest
;

MemTest
	mov	edx, 08088405h
	mul	edx
	add	ebx, 00001007h
	and	ebx, 00FFFEFFh
	add	eax, [ebx+3]
	inc	ecx
MemTestEnd

;
;	JumpTest
;

JumpTest
	nop
	nop
	nop
	mov	edx, 08088405h
	mul	edx
	mov	ebx, eax
	and	ebx, 00FFFFE3h
	inc	ecx
	jmp	ebx
JumpTestEnd

;
;	exception
;

exception
	mov	eax, 0038h
	mov	ds, eax
	mov	es, eax
	mov	[EndFlag], byte 1
	mov	eax, 3
	mov	edx, [esp]
	sub	edx, exceptions+1
	jc	lb_1A
	cmp	edx, 31
	ja	lb_1A
	cmp	[esp+4], word 0030h
	jnz	lb_1A
	add	esp, 3*4
	mov	eax, edx
lb_1A:	mov	[Exception], al
	cmp	[exceptionextra+eax], byte 0
	jz	lb_1B
	pop	eax
	mov	[ExtraWord], ax
lb_1B:	pop	eax
	mov	[ExceptionAddr], eax
	pop	eax
	mov	[ExceptionAddr+4], ax
	add	esp, 4
	jmp	lb_16

;
;	exceptions
;

exceptions
times 32 int3

;
;	interrupt
;

interrupt
	mov	al, 20h
	out	20h, al
	out	0A0h, al
	mov	eax, 0038h
	mov	ds, eax
	mov	es, eax
	mov	[EndFlag], byte 2
	jmp	lb_16

;
;	keyboard
;

keyboard
	in	al, 60h
	mov	al, 0FFh
	out	21h, al
	mov	al, 20h
	out	20h, al
	mov	eax, 0038h
	mov	ds, eax
	mov	es, eax
	mov	[EndFlag], byte 3
	jmp	lb_16

;
;	timer
;

timer
	push	eax
	mov	al, 20h
	out	20h, al
	pop	eax
	iret

;
;	Cyrix specific code
;

GetCyrixID
	mov	[IsCyrix], byte 1
	mov	al, 0FEh
	call	ReadCCR
	mov	[CyrixID+1], ah
	mov	al, 0FFh
	call	ReadCCR
	mov	[CyrixID], ah
	ret

ReadCCR 					; Returns CCRx value in AH
	out	22h, al
	jmp	short $+2
	jmp	short $+2
	jmp	short $+2
	xchg	al, ah
	in	al, 23h
	xchg	al, ah
	ret

WriteCCR					; Needs value for CCRx in AH
	out	22h, al
	jmp	short $+2
	jmp	short $+2
	jmp	short $+2
	mov	al, ah
	out	23h, al
	ret

;
;	VCPIEmu32
;

VCPIEmu32					; VCPI emulation
	cmp	ax, 0DE04h
	jz	_DE04
	cmp	ax, 0DE0Ch
	jz	_DE0Cp
	retf

_DE04:	push	ds
	mov	eax, 0038h
	mov	ds, eax
	dec	dword [bmFreePages]
	jnz	xm_06
	add	[bmCurrent], dword 8
	mov	edx, [bmCurrent]
	movzx	eax, word [edx+xbNumPages]
	mov	[bmFreePages], eax
	mov	eax, [edx+xbAddress]
	mov	[bmAddress], eax
xm_06:	mov	edx, [bmAddress]
	add	[bmAddress], dword 1000h
	mov	ah, 00h
	pop	ds
	retf

_DE0Cp: jmp	0018h:pm_16			; Switch to 16bit pm code

pm_entry					; Protected mode emulated entry
	mov	eax, 0038h
	mov	ds, eax
	lidt	[IDTR]
	ltr	[_TR]
	lldt	[_LDTR]
	jmp	far [_PMEntry]

segment .data

;
;	Initialized data
;

Params		db '?CT1'
EMMDrvName	db 'EMMXXXX0', 0
No386		db 'This program requires 386 processor or better$'
NoVCPIXMS	db 'This program requires EMS driver with VCPI support,', 13, 10
		db 'or XMS driver and processor in real mode (i.e. no EMS or Windows)$'
NoMemory	db 'Not enough free exteded/expanded memory - at least 2MB needed$'
txt0		db 'Chris Dragan',39,'s PC speed benchmark version 4.8 for 386 and above', 13, 10
		db 'Switches:', 13, 10
		db '  /1 - plus 1-second delay before testing (use /1/1/1 for 3 seconds etc.)', 13, 10
;		db '  /T - disable Triple-Fault-Reset test (performed when working with XMS)', 13, 10
		db '  /? - display info', 13, 10, '$'
txtdelay	db 13, 10
		db 'delay . . .$'
txtmode 	db 13, 'Working with $'
txtmode1	db 'VCPI$'
txtmode2	db 'XMS$'
txtmem		db 13, 10, 'Using $'
txt1		db 'MB of RAM', 13, 10
		db 'testing . . .$'
txt2		db 13, 'Test has been interrupted by exception $'
txt21		db ' at address $'
txt22		db ','
Space		db ' $'
EOL		db 13, 10, '$'
txt3		db 13, 'Unexpected hardware interrupt has occured. Terminating$'
txt31		db 13, 'User termination - test stops$'
txt4		db 13, 'Tests successfully completed', 13, 10
		db '͸', 13, 10
		db ' test type    result     ', 13, 10
		db '͵', 13, 10
		db ' arithmetic   $'
txt_copro	db ' ', 13, 10
		db ' coprocessor  $'
txt_mmx 	db ' ', 13, 10
		db ' mmx          $'
txt_mem 	db ' ', 13, 10
		db ' memory read  $'
txt_jmp 	db ' ', 13, 10
		db ' jump         $'
txt_overall	db ' ', 13, 10
		db 'Ĵ', 13, 10
		db ' overall      $'
txt6		db ' ', 13, 10
		db ';', 13, 10, '$'
txt_nofpu	db 'nofpu$'
txt_nommx	db 'nommx$'
txt8		db 13, 10, 'CPU Vendor String "$'
txt9		db 13, 10, 'CPUID Model $'
txt10		db 13, 10, 'Triple-Fault-Reset Model $'
txt11		db 13, 10, 'Cyrix Model $'
txt12		db 13, 10, 'Clock rate $'
txt13		db 13, 10, 'Features $'
txt14		db 13, 10, 'Extended features $'
txt16		db 'MHz$'

GDT		dd 0, 0 			; 0000
sel_vcpi	dd 00000000h, 00409A00h 	; 0008 VCPI code
		dd 00000000h, 00009200h 	; 0010 VCPI data
		dd 00000000h, 00009A00h 	; 0018 VCPI code
sel_gate	dd 00080000h, 00008C00h 	; 0020 VCPI gate
sel_tss 	dd 00000000h, 00408900h 	; 0028 TSS
sel_code	dd 00000000h, 00409A00h 	; 0030 Code 32
sel_data	dd 00000000h, 00409200h 	; 0038 Data
sel_stack	dd 00000000h, 00409200h 	; 0040 Stack
sel_totaldata	dd 00000FFFh, 00C09240h 	; 0048 Tested memory - data
sel_totalcode	dd 00000FFFh, 00C09A40h 	; 0050 Tested memory - code

GDTR		dw 0057h			; Value for GDTR
GDTAddr 	dd 0
IDTR		dw 017Fh			; Value for IDTR
IDTAddr 	dd 0

TFRIDTR 	dw 0,0,0			; TFR data
TFRGDTR 	dw 000Fh
TFRGDTBase	dd 0
TFRGDT		dd 0, 0
		dd 0000FFFFh, 00009A00h

PageFlags	db 07h
Delay		dd 0

MyPICs		db 11h, 20h, 04h, 01h, 11h, 28h, 02h, 01h
DOSPICs 	db 11h, 08h, 04h, 01h, 11h, 70h, 02h, 01h

exceptionextra	db 0,0,0,0,0,0,0,0,1,0,1,1,1,1
times 18	db 0

NBond		dw 0,0,0,8000h,401Fh		; Dword random boundary
NRand		dd 08088405h			; Randomizer
NRoot		dt 0.264			; Root exponent

_mm0		dd 0, 0
_mm3		dd 79730AB5h, 70277151h
_mm4		dd 0, 0
_mm5		dd 0, 0
_mm6		dd 00000001h, 0FFFFFFFFh

EndFlag 	db 0				; Indicates if an error occured
ExitCode_	db 0

NumXMSBlocks	db 0
OnXMS		db 0
NumXMSPages	dw 0
bmCurrent	dd XMSBlockBuffer-8
bmFreePages	dd 1
bmAddress	dd -1

Is386		db 1				; Flags
IsCopro 	db 0
IsCPUID 	db 0
IsModel 	db 0
IsTSC		db 0
IsCyrix 	db 0
IsMMX		db 0
IsExtraFeat	db 0
NoTFR		db 0

ArithTestResult dd 0
CoproTestResult dd 0
MMXTestResult	dd 0
MemTestResult	dd 0
JumpTestResult	dd 0
OverallResult	dd 0

EntryData					; VCPI PM switch entry data
_CR3		dd 0				;	CR3
GDTRAddr	dd 0				;	GDTR
IDTRAddr	dd 0				;	IDTR
_LDTR		dw 0000h			;	LDTR
_TR		dw 0028h			;	TR
_PMEntry	dd main32			;	EIP
		dw 0030h			;	CS

;
;	Uninitialized data
;

section .bss

RandSeed	resd 1

VendorString	resb 12 			; Processor info
BusSpeed	resd 1
CPUIDModel	resw 1
TFRModel	resw 1
CyrixID 	resw 1
Capabilities	resd 1
ExtraFeatures	resd 1

SaveIRQs	resw 1				; Saved data
SaveSP		resw 1
SavePSP 	resw 1
Saved67h	resd 1
SaveIDTR	resw 3
SaveGDTR	resw 3
A20State	resb 1

Exception	resb 1				; Exception data
ExtraWord	resw 1
ExceptionAddr	resw 3

FreeMem 	resw 1				; Offset to test mem descriptors
NumFreePages	resd 1

XMM		resd 1
XMSBlockBuffer	resq 32

IDT		resq 30h			; IDT
TSS		resd 26 			; TSS

freemem 	resd 1024*7
